DIST = 10000
DIST2 = (DIST / 30) * (DIST / 30)
instead.set_music_fading(1000)
set_music ('mus/2.ogg');

game.enable_save = false

function land_rnd(x, a, b)
	local r1, r2
	r1 = bit_mul(a, 25214903917) + 11
	r2 = bit_mul(b, 413158511) + 17
	return  bit_mod(bit_xor(r1, r2), x) + 1
end

function obj_rnd(x, a, b)
	local r1, r2
	r1 = bit_mul(a, 982451653) + 11
	r2 = bit_mul(b, 472882049) + 13
	return  bit_mod(bit_xor(r1, r2), x) + 1
end

function prnd(x, a, b)
	local r1, r2
	if not a then a = X end
	if not b then b = Y end

	r1 = bit_mul(a, 879190841) + 13
	r2 = bit_mul(b, 899809343) + 17
	return bit_mod(bit_xor(r1, r2), x) + 1
end
timer:set(100)
game.timer = function(s)
	if not is_music() then
		set_music 'mus/2.ogg'
	end
end

me().life = function(s)
	if player_moved() then
		food = food - 5
	end

	local d = math.ceil(math.sqrt(X * X + Y * Y) * 30)
	if d >= DIST and here() == cell then
		if type(ACTION_TEXT) == 'string' then
			p (ACTION_TEXT)
		end
		walk 'happyend'
		return
	end
	if food <= 0 then
		food = 0;
		if type(ACTION_TEXT) == 'string' then
			p (ACTION_TEXT)
		end
		lifeoff(me())
		game.lifes:disable_all()
		walk 'theend'
		return
	end
end

hole = obj {
	nam = _'ход';
	Exam = function(s)
		p [[Просто выход из берлоги.]];
		if exist(brevno) then
			if not seen(brevno) then
				p [[Медведь заметил, ]];
			else
				p [[Медведь видит, ]];
			end
			p [[что выход завален стволом дерева!
			Медведь очень зол!]];
			brevno:enable();
		end
	end;
	alias [[Exam: Search ]];
	Rock = [[Медведь не хочет ломать свою берлогу.]];
	attr [[door, static]];
	door_to = function(s)
		if here() == berloga then
			return 'cell';
		end
		return 'berloga'
	end;
}
brevno = obj {
	nam = _'дерево';
	before_Take = [[Дерево слишком большое, чтобы взять его с собой.]];
	Exam = function(s)
		if here() == cell then
			p [[Поваленная сосна. Основание ствола находится в западной стороне.]]
		else
			p [[Ствол дерева завалил выход.]]
		end
	end;
	Rock = function(s)
		if here() == cell then
			return [[Медведь пошатал ствол дерева!]];
		end
		p [[Медведь с ревом зашатал ствол дерева и отбросил его.]];
		remove(s);
	end;
}:disable();

berloga = room {
	nam = 'В берлоге';
	dsc = [[В медвежьей берлоге ничего нет.]];
	obj = { 'hole', 'brevno' };
	Smell = [[Пахнет медведем.]];
	footer = [[Выход из берлоги ведет наверх.]];
	u_to = 'cell';
	exit = function(s, t)
		if t ~= cell then
			return
		end
		if exist(brevno) then
			if not seen(brevno) then
				brevno:enable();
				p [[Медведь решил выбраться наружу. Но
				оказалось, что выход завален деревом.]]
			else
				p [[Выход завален деревом.]]
			end
			return false
		end
		lifeon(me())
	end;
}
N = 0;
S = 1;
E = 2;
W = 3;

function walk_x(s, dir)
	if not world[Y] then
		world[Y] = {}
	end

	world[Y][X] = objs(s)

	if dir == N then
		Y = Y - 1
	elseif dir == S then
		Y = Y + 1
	elseif dir == E then
		X = X + 1
	elseif dir == W then
		X = X - 1
	end
	walk(cell);
end
local function walk_n(s)
	return walk_x(s, N)
end
local function walk_s(s)
	return walk_x(s, S)
end
local function walk_e(s)
	return walk_x(s, E)
end
local function walk_w(s)
	return walk_x(s, W)
end

at_berloga = room {
	nam = 'У берлоги';
	dsc = [[Вокруг снег. Сыро и холодно.]];
	d_to = 'berloga';
	obj = { 'hole', 'brevno' };
	n_to = walk_n;
	s_to = walk_s;
	e_to = walk_e;
	w_to = walk_w;
}

global { X = 0, Y = 0};

FOREST = 1
FIELD = 2
TOWN = 4
LAKE = 5
RAILS = 6
function land(x, y)
	local d = x * x + y * y
	if x == 256 and y < -180 then
		return RAILS
	end
	if d >= DIST2 then
		return TOWN
	end
	if x == 0 and y == 0 then
		return FOREST
	end
	local i = land_rnd(13, x, y);
	if i <= 10 then
		return FOREST;
	elseif i == 11 or i == 12 then
		return FIELD;
	elseif i == 13 then
		return LAKE;
	end
end

function somewhat(x, y)
	if world[y] and world[y][x] then
		if world[y][x][1] then
			return world[y][x][1].nam
		end
		return
	end
end

function object(x, y)	
	if world[y] and world[y][x] then
		if world[y][x][1] then
			return world[y][x][1].oid
		end
		return
	end
	if wormholes[y] and wormholes[y][x] then
		return 10003
	end
	local d = math.ceil(math.sqrt(x * x + y * y) * 30)

	if d >= DIST then
		return
	end

	if land(x, y) == RAILS then
		if y == -210 then
			return 10001
		elseif y == -209 then
			return 10002
		end
		return
	end
	if x == -1 and y == 0 then
		return getobj 'дровосек'
	end
	if land(x, y) == LAKE then
		local r = prnd(117, x, y)
		if r < 20 then
			return getobj 'прорубь'
		elseif r < 40 then
			return getobj 'рыбак'
		end
		return
	end
	local dist = math.ceil(math.sqrt(x * x + y * y));
	local m = math.ceil(dist)
	if m > #objects then
		m = #objects
	end
	if m == 0 then
		m = 1
	end
	local l = obj_rnd(m  + dist * 5, x, y)
	if l > dist * 5 then
		l = (l - dist * 5)
	else
		return
	end
	m = objects[l]
	if m.only and m.only ~= land(x, y) then
		return
	end
	return l -- obj_rnd(l, x, y)
end

global { food = 90; };

doencfile "objects.lua"

parser.events.after_Eat = function(self, s)
	p [[Медведь пополнил свои силы.]]
	food = food + s.food;
	remove(s)
end

function mkobj(id)
	local o
	if id > 10000 then
		o = uniq_objects[id - 10000]
	else
		o = objects[id]
	end
	local v = obj {
		nam = o[1];
		dsc = o[2];
		Exam = o[3];
		eatable = (o.food ~= nil);
		oid = id;
		save = function(s, name, h, need)
			if need then
				h:write("%s = mkobj(%d)", name, s.oid);
			end
			stead.savemembers(h, s, name, false);	
		end;
	}
	local a,b
	for a,b in pairs(o) do
		if type(a) == 'string' then 
			v[a] = b
		end
	end
	return v
end

global {
	world = { }
}
cell = room {
	enter = function(s) -- fill objects
		if not visited() then
			set_music ('mus/test2.ogg',1)
		end
		if world[Y] and world[Y][X] then
			s.obj = list(world[Y][X])
		else
			local v = list {}
			v:zap() -- mark dirty
			s.obj = v
			if X == 0 and Y == 0 then
				put(hole)
				put(brevno)
			else
				local i = object(X, Y)
				if i then
					local o = new ([[ mkobj(]]..tostring(i)..[[) ]])
					put(o);
					if o.init then o:init() end
				end
			end
			if land(X, Y) ~= LAKE and land(X, Y) ~= RAILS then
				objs()._step = true
			end
			if not world[Y] then
				world[Y] = {}
			end
			world[Y][X] = v
		end
		if food <= 0 then
			food = 0;
			lifeoff(me())
			game.lifes:disable_all()
			walk 'theend'
			return
		end
	end;
	dsc = function(s)
		local l = land(X, Y)

		if l == FOREST then
			p 'Медведя окружает лес.';
		elseif l == FIELD then
			p 'Медведь вышел на заснеженную поляну.'
		elseif l == LAKE then
			p 'Медведь вышел к замерзшему озеру.'
		elseif l == TOWN then
			p 'Медведь выбрался из леса.'
		elseif l == RAILS then
			p 'Медведь вышел к заброшенной железной дороге.'
		end
	end;
	nam = function(s)
		local l = land(X, Y)
		if l == FOREST then
			p 'Лес';
		elseif l == FIELD then
			p 'Поляна'
		elseif l == RAILS then
			p 'Железная дорога'
		elseif l == LAKE then
			p 'Озеро'
		end
	end;
	n_to = walk_n;
	s_to = walk_s;
	e_to = walk_e;
	w_to = walk_w;
}
instead.get_title = function(s)
	return txtb(txtu(txtnb(stead.dispof(stead.here())))..txttab("50%", "center")..txtu(txtnb('Ходы: '..tostring(stead.time())))..txttab("100%", "right")..txtu(txtnb('Жир: '..tostring(food))))
end

theend = room {
	nam = 'Конец';
	verbs = {
		{ "Next", "заново" };
	};
	Next = code [[ stead.restart(); ]];
	gfx = 'gfx/end.png';
	entered = function(s)
		set_music 'mus/12.ogg'
		s._d = math.sqrt(X*X + Y*Y) * 30 / 1000;
		if not prefs.max then
			prefs.max = s._d
		end
		if s._d > prefs.max then
			prefs.max = s._d
		end
		if not prefs.num then
			prefs.num = 0
		end
		prefs.num = prefs.num + 1
		prefs:store()
	end;
	dsc = function(s)
		p [[Медведь погиб от истощения]]; 
		local i = tostring(string.format("%0.1f",s._d))..' км. от берлоги.';
		p ('в '..i)
		local r = tostring(string.format("%0.1f",prefs.max))..' км.';
		p ('Рекорд: '..r);
	end;
}

happyend = cutscene {
	nam = 'Конец';
	entered = function(s)
		set_music 'mus/hend.ogg'
		s._d = math.sqrt(X*X + Y*Y) * 30 / 1000;
		if not prefs.max then
			prefs.max = s._d
		end
		if s._d > prefs.max then
			prefs.max = s._d
		end
		s._t = time();
	end;
	dsc = function(s)
		p ([[Медведь добрался до гипермаркета за ]], s._t, ' ходов.'); 
		pn [[Он успел пополнить запасы жира, прежде чем в гипермаркет прибыла полиция.]]
		pn (txtc(txtb([[Поздравляю!]])));
		pn (txtc "")
		pn (txtc[[Автор кода: Школьник]])
		pn (txtc[[Иллюстрации: j-maks]])
		pn (txtc[[Музыка: excelenter]])
		pn (txtc "")
		pn (txtc[[При создании этой треш-игры были заимствованы идеи из следующих игр:]])
		pn (txtc "")
		pn (txtc[[:: Enviro-Bear 2000 - Operation Hibernation ::]])
		pn (txtc[[:: robotfindskitty ::]])
		pn (txtc[[:: elite :: ]])
		pn (txtc[[:: Созвездие: Полет в бездну ::]])
		pn (txtc[[:: Различные рогалики ::]])
	end;
	walk_to = 'happyend2';
}

happyend2 = room {
	nam = 'Конец';
	entered = function(s)
		theme.set("scr.gfx.x", 0)
		theme.set("scr.gfx.y", 0)
		theme.set("scr.gfx.w", 800)
		theme.set("scr.gfx.h", 600)
		theme.set("scr.gfx.bg", 'box:800x600,black')
		theme.win.geom(800,600,0,0)
		theme.inv.mode 'disabled'
	end;
	pic = function(s)
		if not s.image then
			stead.busy(true)
			s.image = sprite.load 'box:800x600,black'
			local y,x
			local y, x
			for x = 1, 300 do
				local c = rnd(128) + 128
				c = string.format("#%02x%02x%02x", c, c, c);
				sprite.pixel(s.image, rnd(800), rnd(600), c)
			end
			for y = -333,333 do
				for x = -333,333 do
					stead.busy(true)
					if world[y] and world[y][x] and world[y][x]._step then
						sprite.pixel(s.image, x + 400, y + 300, 'red')
					else
						local l = land(x, y)
						if l == LAKE then
							sprite.pixel(s.image, x + 400, y + 300, 'lightblue')
						elseif l == FOREST then
							sprite.pixel(s.image, x + 400, y + 300, '#fffafa')
						elseif l == FIELD then
							sprite.pixel(s.image, x + 400, y + 300, '#ddd9d9')
						elseif l == RAILS then
							if y == -210 or y == -209 then
								sprite.pixel(s.image, x + 400, y + 300, 'red')
							else
								sprite.pixel(s.image, x + 400, y + 300, 'black')
							end
						end
					end
				end
			end
			local t = sprite.text(FN, "ПУТЬ МЕДВЕДЯ", 'white', 1)
			local w, h = sprite.size(t)
			sprite.draw(t, s.image, 8, 8)
			sprite.free(t)

			t = sprite.text(FN, string.format("ЖИР: %d", food), 'white', 1)
--			local w, h = sprite.size(t)
			sprite.draw(t, s.image, 8, h * 2)
			sprite.free(t)

			stead.busy(false)
		end
		return s.image
	end;
}

