-- $Name: Путь медведя$
-- $Version: 0.9$
-- $Author: Школьник$

instead_version "1.8.3"
require "hideinv"
require "quotes"
require "dash"
require "prefs"
require "click"
require "sprites"
require "nolife"
require "para"

dofile "parser/metaparser.lua"
require "kbd"

global { bg = 'gfx/1.png' } 

function init()
	sp_forest = sprite.load "box:16x16,#fffafa"
	sp_field = sprite.load "box:16x16,#ddd9d9"
	sp_lake = sprite.load "box:16x16,lightblue"
	sp_bear = sprite.load "gfx/dot.png" --box:16x16,red"
	sp_gray1 = sprite.load "box:16x16,#1d1d1d"
	sp_gray2 = sprite.load "box:16x16,gray"
	sp_obj = sprite.load "box:8x8,black"
	FN = sprite.font('gfx/sans.ttf', 12)
	sp_map = sprite.load "box:114x114,black"
	sp_step = sprite.load "gfx/steps.png"
	sp_rails = sprite.load "gfx/rails.png"
end

function start()
	sp_bg = sprite.load(bg)
end

hook_keys ('left', 'right', 'up', 'down');

game.kbd = function(s, press, k)
	if not press or here() ~= cell then
		return
	end
	parser:reset()
	if k == 'up' then
		input._txt = 'север'
	elseif k == 'down' then
		input._txt = 'юг'
	elseif k == 'right' then
		input._txt = 'восток'
	elseif k == 'left' then
		input._txt = 'запад'
	end
	parser_menu_items:fill()
	parser_menu_items:completion()
	parser:enter()
	return true
end
input.cursor = img 'cursor.gif'

old_click = game.click

game.click = function(s, m, x, y, px, py, ...)
	local W = 3
	local H = 3
	if px and py and here() == cell then
		px = px - (90 - 16)
		py = py - 32
		x = math.floor(px / 16) - W
		y = math.floor(py / 16) - H
		if y > H or y < -H or x > W or x < -W then
			return
		end
		parser:reset()
		if math.abs(x) > math.abs(y) then
			if x > 0 then
				input._txt = 'восток'
			else
				input._txt = 'запад'
			end
		else
			if y > 0 then
				input._txt = 'юг'
			else
				input._txt = 'север'
			end
		end
		parser_menu_items:fill()
		parser_menu_items:completion()
		parser:enter()
		return true
	end
	return old_click(s, m, x, y, px, py, ...)
end;

sp_cache = {}

game.pic = function(s)
	local W = 3
	local H = 3
	local XOFF=90-16
	local YOFF=32
	local p = 'box:'..tostring(16*(W*2+1))..'x'..tostring(16*(H*2+1))..',white'
	local x, y

	if not s.image then
		s.image = sprite.blank(280, 600)
		sprite.copy(sp_bg, s.image, 0, 0)
	end

	if here() == cell then
		local ln = land(X, Y)
		if ln == LAKE then
			local a = exist 'рыбак'
			if a then
				ln = ln + 1000
				if prnd(3) == 1 then
					ln = ln + 1
				end
			elseif exist 'прорубь' then
				ln = ln + 1002
			end
		end
		local t = {
			[FOREST] = 'gfx/1.png';
			[FIELD] = 'gfx/2.png';
			[LAKE] = 'gfx/4.png';
			[RAILS] = 'gfx/3.png';
			[LAKE + 1000] = 'gfx/5.png';
			[LAKE + 1001] = 'gfx/6.png';
			[LAKE + 1002] = 'gfx/6-1.png';
		}
		if t[ln] ~= bg then
			bg = t[ln]
			if sp_cache[ln] then
				sp_bg = sp_cache[ln]
			else
				sp_bg = sprite.load (t[ln])
				sp_cache[ln] = sp_bg
			end
			sprite.copy(sp_bg, s.image, 0, 0)
		end
	end

	if here() == cell then
		sprite.copy(sp_map, s.image, XOFF -1 , YOFF -1)
		for y=-H,H do
			for x=-W,W do
				local b = land(X + x, Y + y)
				if b == FOREST then
					sprite.copy(sp_forest, s.image, XOFF + (x + W) * 16, YOFF + (y + H) * 16);
				end
				if b == LAKE then
					sprite.copy(sp_lake, s.image, XOFF + (x + W) * 16, YOFF + (y + H) * 16);
				end
				if b == FIELD then
					sprite.copy(sp_field, s.image, XOFF + (x + W) * 16, YOFF + (y + H) * 16);
				end

				if b == RAILS then
					sprite.copy(sp_rails, s.image, XOFF + (x + W) * 16, YOFF + (y + H) * 16);
				end

				if b == TOWN then
					if prnd(100, X + x, Y + y) > 50 then
						sprite.copy(sp_gray1, s.image, XOFF + (x + W) * 16, YOFF + (y + H) * 16);
					else
						sprite.copy(sp_gray2, s.image, XOFF + (x + W) * 16, YOFF + (y + H) * 16);
					end
				end
				local a = object(X + x, Y + y)
				if not a and somewhat(X + x, Y + y) then
					if not sp_somewhat then
						sp_somewhat = sprite.text(FN, '?', 'black', 1)
					end
					local image_w, image_h = sprite.size(sp_somewhat)
					local dx = math.ceil((16 - image_w) / 2)
					local dy = math.ceil((16 - image_h) / 2)
					sprite.draw(sp_somewhat, s.image, XOFF + (x + W) * 16+ dx, YOFF + (y + H) * 16 + dy);
				elseif a then
					local ob = objects
					if a > 10000 then
						ob = uniq_objects
						a = a - 10000
					end
					if not ob[a].image then
						if not ob[a].sp then
							ob[a].sp = string.char(0x61 + a)
						end
						ob[a].image = sprite.text(FN, ob[a].sp, 'black', 1)
						ob[a].image_w, ob[a].image_h = sprite.size(ob[a].image)
					end
					local dx = math.ceil((16 - ob[a].image_w) / 2)
					local dy = math.ceil((16 - ob[a].image_h) / 2)
					sprite.draw(ob[a].image, s.image, XOFF + (x + W) * 16+ dx, YOFF + (y + H) * 16 + dy);
				end
				if not a and not somewhat(X +x, Y + y) and world[Y + y] and world[Y + y][X + x] and world[Y + y][X + x]._step then
					sprite.draw(sp_step, s.image, XOFF + (x + W) * 16, YOFF + (y + H) * 16);
				end
			end
		end
		sprite.draw(sp_bear, s.image, XOFF + 16*W, YOFF + 16*H);
		local c = string.format("%d:%d", X, -Y)
		local coord = sprite.text(FN, c, 'black')
		local w,h = sprite.size(coord)
		sprite.draw(sp_bg, XOFF, YOFF + 16*(H*2+1) + 2, 16*(W*2+1), 16, s.image, XOFF, YOFF + 16*(H*2+1) + 2);
		sprite.draw(coord, s.image, XOFF + 16*W+8 - w/2, YOFF + 16*(H*2+1) + 2);
		sprite.free(coord)
	end
	return s.image
end
--'bar.png'

morph.debug = false
morph.yo = false
morph:init ('main.lua', 'game.lua', 'objects.lua')
parser.err_filter = false

pl = parser_player {
	nam = _'медведь';
	person = 3;
	Exam = [[Медведь осмотрел себя.]];
}

dofile "game.lua"

main = room {
	nam = 'Путь медведя';
	walk_to = 'berloga';
	gfx = 'gfx/bear.png';
	entered = [[Небольшая треш-игра неизвестного жанра. Написана зимой 2013 года.]];
	dsc = [[Лес. Зима. Страшный грохот разбудил медведя в берлоге. Медведь голоден и раздражен.
		Рррррррррр!]];
	Next = code [[ walk 'berloga' ]];
	Help = code [[walk 'help' ]];
	Skip = function(s)
		brevno:enable()
		remove(brevno, berloga)
		walk 'cell'
		lifeon(me())
	end;
	verbs = {
		{ "Help", "помощь" };
		{ "Next", "дальше" };
		{ "Skip", function(s) if prefs.num then return "пропустить" end end};
	};
}
help = cutscene {
	nam = 'Помощь';
	dsc = {[[Представьте себя медведем, который не по своей воле проснулся из зимней спячки... от шума, грохота снаружи своей берлоги...
Медведь очень зол, он стал медведем-шатуном, его заспанные глаза застилает пелена ярости, он хочет шатать, все шатать, шатать полностью...
Медведь осторожный зверь он может ждать когда охотится, он умеет хорошо видеть, искать и чутко нюхать, медведь может учуять еду или врага за километры...
Медведь рычит, он просто рычит, он рычит на все вокруг, на весь огромный зимний лес и его обитателей...
Медведь голоден, его вырвали из прекрасной зимней спячки, и теперь он крайне голоден, он ест все что встречается на его пути...^^
Медведь суров... ему не нужно лишнего, чтобы понять окружающий мир и найти себе пропитание всего лишь --
есть, ждать, идти, искать, нюхать, осмотреть, рычать, шатать...
Думайте как медведь, шатайте и рычите как медведь, будьте медведем, чтобы пройти по его пути!]],
[[Вы можете вводить команды с клавиатуры или мышкой.
	Медведь может: рычать, шатать, искать (под/в/на), ходить, есть.^^ 
	Навигация может осуществляться: клавишами курсора, мышкой (щелкая по карте) или вводя команды: север, восток, запад, юг.^^
	Если вы играете клавиатурой, используйте "пробел" или "таб" для автодополнения.
	Чтобы быстро осмотреться -- нажмите "ввод" или введите "осмотреть".]]};
	walk_to = 'main'
}
parser.events.Help = [[
	Медведи не умеют читать.
]]

parser.events.Roar = function(s, w)
	if not w then
		return "Рррррррррррр!"
	end
	return ("Медведь зарычал на "..w:M 'вн'..'.')
end

parser.events.Rock = function(s, w)
	if w.static then
		p (w:CM 'вн'..[[ нельзя шатать.]])
		return
	end
	return ("Медведь пошатал "..w:M 'вн'..'.')
end
parser.events.before_Wait = function()
	food = food - 2
	Wait = time()
	if food <= 0 then
		food = 0;
		walk(theend)
		return true
	end
end
game.verbs = {}; -- empty verbs

-- parser.verb.Inventory()
parser.verb.Exam()
parser.verb.Walk()
parser.verb.Search()
-- parser.verb.Open()
-- parser.verb.Close()
-- parser.verb.Eat()
Verb { "Eat %2", "есть|~съесть", "{inv}вн|{obj}вн" };
-- parser.verb.Take()
-- parser.verb.Drop()
parser.verb.Wait()

-- Verb { "Inventory", "с собой" };
Verb { "Smell %2", "нюхать|~понюхать", "{}|{obj}вн|{inv}вн" };
Verb { "Roar %3", "рычать", "{}|на", "{obj}вн" }
Verb { "Rock %2", "шатать|~ударить|~бить|~разбить|~сломать", "{obj}вн" }
Verb { "Help", "~помощь|~инфо" }
